diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/supported-rates.h ns-3.39/src/wifi/model/supported-rates.h
--- ns-3.38/src/wifi/model/supported-rates.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/supported-rates.h	2023-07-05 14:23:48.121428500 -0700
@@ -22,99 +22,70 @@
 
 #include "wifi-information-element.h"
 
+#include <optional>
+#include <vector>
+
 namespace ns3
 {
 
-class SupportedRates;
-
 /**
- * \brief The Extended Supported Rates Information Element
+ * \brief The Supported Rates Information Element
  * \ingroup wifi
  *
- * This class knows how to serialise and deserialise the Extended
- * Supported Rates Element that holds (non-HT) rates beyond the 8 that
- * the original Supported Rates element can carry.
+ * This class knows how to serialise and deserialise the Supported
+ * Rates Element that holds the first 8 (non-HT) supported rates.
  *
- * The \c SupportedRates class still records all the rates, and an
- * instance of \c ExtendedSupportedRatesIE lies within \c
- * SupportedRates.
+ * The \c ExtendedSupportedRatesIE class deals with rates beyond the first 8.
  */
-class ExtendedSupportedRatesIE : public WifiInformationElement
+class SupportedRates : public WifiInformationElement
 {
+    friend struct AllSupportedRates;
+
   public:
-    ExtendedSupportedRatesIE();
-    /**
-     * Create an extended supported rates information element
-     * from the given rates.
-     *
-     * \param rates the extended supported rates
-     */
-    ExtendedSupportedRatesIE(SupportedRates* rates);
+    SupportedRates();
 
     // Implementations of pure virtual methods of WifiInformationElement
     WifiInformationElementId ElementId() const override;
+    void Print(std::ostream& os) const override;
 
     /**
-     * Set supported rates.
+     * Return the rate (converted back to raw value) at the given index.
      *
-     * \param rates the supported rates
+     * \param i the given index
+     * \return the rate in bps
      */
-    void SetSupportedRates(SupportedRates* rates);
+    uint32_t GetRate(uint8_t i) const;
 
-  private:
+  protected:
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
 
-    /**
-     * This member points to the SupportedRates object that contains the
-     * actual rate details. This class is a friend of that, so we have
-     * access to all the private data we need.
-     */
-    SupportedRates* m_supportedRates;
+    std::vector<uint8_t> m_rates; //!< List of supported bit rates (divided by 500000)
 };
 
 /**
- * \brief The Supported Rates Information Element
+ * \brief The Extended Supported Rates Information Element
  * \ingroup wifi
  *
- * This class knows how to serialise and deserialise the Supported
- * Rates Element that holds the first 8 (non-HT) supported rates.
- *
- * The \c ExtendedSupportedRatesIE class (of which an instance exists
- * in objects of this class) deals with rates beyond the first 8.
+ * This class knows how to serialise and deserialise the Extended
+ * Supported Rates Element that holds (non-HT) rates beyond the 8 that
+ * the original Supported Rates element can carry.
  */
-class SupportedRates : public WifiInformationElement
+class ExtendedSupportedRatesIE : public SupportedRates
 {
   public:
-    SupportedRates();
-
-    /**
-     * Type conversion operator
-     *
-     * \param rates the reference const SupportedRates
-     */
-    SupportedRates(const SupportedRates& rates);
-
     // Implementations of pure virtual methods of WifiInformationElement
     WifiInformationElementId ElementId() const override;
+};
 
-    /**
-     * Assignment operator
-     *
-     * \param rates the rates to assign
-     * \returns the assigned value
-     */
-    SupportedRates& operator=(const SupportedRates& rates);
-
-    /**
-     * This defines the maximum number of supported rates that a STA is
-     * allowed to have. Currently this number is set for IEEE 802.11b/g and SISO IEEE 802.11n
-     * stations which need 2 rates each from Clauses 15 and 18, and then 8
-     * from Clause 19.
-     */
-    static const uint8_t MAX_SUPPORTED_RATES = 32;
-
+/**
+ * \brief Struct containing all supported rates.
+ * \ingroup wifi
+ *
+ */
+struct AllSupportedRates
+{
     /**
      * Add the given rate to the supported rates.
      *
@@ -170,44 +141,11 @@
      * \return the number of supported rates
      */
     uint8_t GetNRates() const;
-    /**
-     * Return the rate at the given index.
-     * Return the rate (converted back to raw value) at the given index.
-     *
-     * \param i the given index
-     * \return the rate in bps
-     */
-    uint32_t GetRate(uint8_t i) const;
 
-    /**
-     * We support the Extended Supported Rates Information Element
-     * through the ExtendedSupportedRatesIE object which is declared
-     * above. We allow this class to be a friend so that it can access
-     * our private data detailing the rates, and create an instance as
-     * extended.
-     */
-    friend class ExtendedSupportedRatesIE;
-    std::optional<ExtendedSupportedRatesIE> extended; //!< extended supported rates info element
-
-  private:
-    uint16_t GetInformationFieldSize() const override;
-    void SerializeInformationField(Buffer::Iterator start) const override;
-    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
-
-    uint8_t m_nRates;                     //!< Number of supported rates
-    uint8_t m_rates[MAX_SUPPORTED_RATES]; //!< List of supported bit rates (divided by 500000)
+    SupportedRates rates;                                  //!< supported rates
+    std::optional<ExtendedSupportedRatesIE> extendedRates; //!< supported extended rates
 };
 
-/**
- * Serialize SupportedRates to the given ostream.
- *
- * \param os output stream
- * \param rates the SupportedRates
- *
- * \return std::ostream
- */
-std::ostream& operator<<(std::ostream& os, const SupportedRates& rates);
-
 } // namespace ns3
 
 #endif /* SUPPORTED_RATES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/txop.cc ns-3.39/src/wifi/model/txop.cc
--- ns-3.38/src/wifi/model/txop.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/txop.cc	2023-07-05 14:23:48.121428500 -0700
@@ -68,8 +68,7 @@
                 "The minimum values of the contention window for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetMinCws,
-                                                                         &Txop::GetMinCws),
+                MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMinCws, &Txop::GetMinCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
             .AddAttribute("MaxCw",
                           "The maximum value of the contention window (just for the first link, "
@@ -84,8 +83,7 @@
                 "The maximum values of the contention window for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetMaxCws,
-                                                                         &Txop::GetMaxCws),
+                MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMaxCws, &Txop::GetMaxCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
             .AddAttribute(
                 "Aifsn",
@@ -101,8 +99,7 @@
                 "The values of AIFSN for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetAifsns,
-                                                                         &Txop::GetAifsns),
+                MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetAifsns, &Txop::GetAifsns),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
             .AddAttribute("TxopLimit",
                           "The TXOP limit: the default value conforms to non-QoS "
@@ -112,14 +109,13 @@
                           MakeTimeAccessor((void(Txop::*)(Time)) & Txop::SetTxopLimit,
                                            (Time(Txop::*)() const) & Txop::GetTxopLimit),
                           MakeTimeChecker())
-            .AddAttribute(
-                "TxopLimits",
-                "The values of TXOP limit for all the links",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                AttributeContainerValue<TimeValue>(),
-                MakeAttributeContainerAccessor<TimeValue, std::list>(&Txop::SetTxopLimits,
-                                                                     &Txop::GetTxopLimits),
-                MakeAttributeContainerChecker<TimeValue>(MakeTimeChecker()))
+            .AddAttribute("TxopLimits",
+                          "The values of TXOP limit for all the links",
+                          TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                          AttributeContainerValue<TimeValue>(),
+                          MakeAttributeContainerAccessor<TimeValue>(&Txop::SetTxopLimits,
+                                                                    &Txop::GetTxopLimits),
+                          MakeAttributeContainerChecker<TimeValue>(MakeTimeChecker()))
             .AddAttribute("Queue",
                           "The WifiMacQueue object",
                           PointerValue(),
@@ -246,7 +242,7 @@
     auto& link = GetLink(linkId);
     bool changed = (link.cwMin != minCw);
     link.cwMin = minCw;
-    if (changed == true)
+    if (changed)
     {
         ResetCw(linkId);
     }
@@ -275,7 +271,7 @@
     auto& link = GetLink(linkId);
     bool changed = (link.cwMax != maxCw);
     link.cwMax = maxCw;
-    if (changed == true)
+    if (changed)
     {
         ResetCw(linkId);
     }
@@ -515,9 +511,7 @@
 Txop::Queue(Ptr<WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
-    const auto linkIds =
-        m_mac->GetMacQueueScheduler()->GetLinkIds(m_queue->GetAc(),
-                                                  WifiMacQueueContainer::GetQueueId(mpdu));
+    const auto linkIds = m_mac->GetMacQueueScheduler()->GetLinkIds(m_queue->GetAc(), mpdu);
     for (const auto linkId : linkIds)
     {
         if (m_mac->GetChannelAccessManager(linkId)->NeedBackoffUponAccess(this))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-capabilities.cc ns-3.39/src/wifi/model/vht/vht-capabilities.cc
--- ns-3.38/src/wifi/model/vht/vht-capabilities.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-capabilities.cc	2023-07-05 14:23:48.121428500 -0700
@@ -63,6 +63,12 @@
     return IE_VHT_CAPABILITIES;
 }
 
+void
+VhtCapabilities::Print(std::ostream& os) const
+{
+    os << "VHT Capabilities=" << GetVhtCapabilitiesInfo() << "|" << GetSupportedMcsAndNssSet();
+}
+
 uint16_t
 VhtCapabilities::GetInformationFieldSize() const
 {
@@ -384,13 +390,4 @@
     return m_rxHighestSupportedLongGuardIntervalDataRate;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const VhtCapabilities& vhtCapabilities)
-{
-    os << vhtCapabilities.GetVhtCapabilitiesInfo() << "|"
-       << vhtCapabilities.GetSupportedMcsAndNssSet();
-
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-capabilities.h ns-3.39/src/wifi/model/vht/vht-capabilities.h
--- ns-3.38/src/wifi/model/vht/vht-capabilities.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-capabilities.h	2023-07-05 14:23:48.121428500 -0700
@@ -38,6 +38,7 @@
 
     // Implementations of pure virtual methods of WifiInformationElement
     WifiInformationElementId ElementId() const override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the VHT Capabilities Info field in the VHT Capabilities information element.
@@ -241,16 +242,6 @@
                                                             ///< guard interval data rate
 };
 
-/**
- * output stream output operator
- *
- * \param os the output stream
- * \param vhtCapabilities the VHT capabilities
- *
- * \returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const VhtCapabilities& vhtCapabilities);
-
 } // namespace ns3
 
 #endif /* VHT_CAPABILITY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-operation.cc ns-3.39/src/wifi/model/vht/vht-operation.cc
--- ns-3.38/src/wifi/model/vht/vht-operation.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-operation.cc	2023-07-05 14:23:48.121428500 -0700
@@ -36,6 +36,13 @@
     return IE_VHT_OPERATION;
 }
 
+void
+VhtOperation::Print(std::ostream& os) const
+{
+    os << "VHT Operation=" << +GetChannelWidth() << "|" << +GetChannelCenterFrequencySegment0()
+       << "|" << +GetChannelCenterFrequencySegment1() << "|" << GetBasicVhtMcsAndNssSet();
+}
+
 uint16_t
 VhtOperation::GetInformationFieldSize() const
 {
@@ -129,14 +136,4 @@
     return length;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const VhtOperation& VhtOperation)
-{
-    os << +VhtOperation.GetChannelWidth() << "|"
-       << +VhtOperation.GetChannelCenterFrequencySegment0() << "|"
-       << +VhtOperation.GetChannelCenterFrequencySegment1() << "|"
-       << VhtOperation.GetBasicVhtMcsAndNssSet();
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-operation.h ns-3.39/src/wifi/model/vht/vht-operation.h
--- ns-3.38/src/wifi/model/vht/vht-operation.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-operation.h	2023-07-05 14:23:48.121428500 -0700
@@ -39,6 +39,7 @@
 
     // Implementations of pure virtual methods of WifiInformationElement
     WifiInformationElementId ElementId() const override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the Channel Width field in the VHT Operation information element.
@@ -115,16 +116,6 @@
     uint16_t m_basicVhtMcsAndNssSet; ///< basic VHT MCS NSS set
 };
 
-/**
- * output stream output operator
- *
- * \param os the output stream
- * \param VhtOperation the VHT operation
- *
- * \returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const VhtOperation& VhtOperation);
-
 } // namespace ns3
 
 #endif /* VHT_OPERATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-phy.cc ns-3.39/src/wifi/model/vht/vht-phy.cc
--- ns-3.38/src/wifi/model/vht/vht-phy.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-phy.cc	2023-07-05 14:23:48.121428500 -0700
@@ -250,10 +250,8 @@
     NS_LOG_FUNCTION(this << psdus << txVector << ppduDuration);
     return Create<VhtPpdu>(psdus.begin()->second,
                            txVector,
-                           m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                               txVector.GetChannelWidth()),
+                           m_wifiPhy->GetOperatingChannel(),
                            ppduDuration,
-                           m_wifiPhy->GetPhyBand(),
                            ObtainNextUid(txVector));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-ppdu.cc ns-3.39/src/wifi/model/vht/vht-ppdu.cc
--- ns-3.38/src/wifi/model/vht/vht-ppdu.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-ppdu.cc	2023-07-05 14:23:48.121428500 -0700
@@ -24,6 +24,7 @@
 #include "vht-phy.h"
 
 #include "ns3/log.h"
+#include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-phy.h"
 #include "ns3/wifi-psdu.h"
 
@@ -34,18 +35,16 @@
 
 VhtPpdu::VhtPpdu(Ptr<const WifiPsdu> psdu,
                  const WifiTxVector& txVector,
-                 uint16_t txCenterFreq,
+                 const WifiPhyOperatingChannel& channel,
                  Time ppduDuration,
-                 WifiPhyBand band,
                  uint64_t uid)
     : OfdmPpdu(psdu,
                txVector,
-               txCenterFreq,
-               band,
+               channel,
                uid,
                false) // don't instantiate LSigHeader of OfdmPpdu
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << ppduDuration << band << uid);
+    NS_LOG_FUNCTION(this << psdu << txVector << channel << ppduDuration << uid);
     SetPhyHeaders(txVector, ppduDuration);
 }
 
@@ -53,20 +52,8 @@
 VhtPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
 {
     NS_LOG_FUNCTION(this << txVector << ppduDuration);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    LSigHeader lSig;
-    SetLSigHeader(lSig, ppduDuration);
-
-    VhtSigHeader vhtSig;
-    SetVhtSigHeader(vhtSig, txVector, ppduDuration);
-
-    m_phyHeaders->AddHeader(vhtSig);
-    m_phyHeaders->AddHeader(lSig);
-#else
     SetLSigHeader(m_lSig, ppduDuration);
     SetVhtSigHeader(m_vhtSig, txVector, ppduDuration);
-#endif
 }
 
 void
@@ -105,27 +92,7 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    auto phyHeaders = m_phyHeaders->Copy();
-
-    LSigHeader lSig;
-    if (phyHeaders->RemoveHeader(lSig) == 0)
-    {
-        NS_FATAL_ERROR("Missing L-SIG header in VHT PPDU");
-    }
-
-    VhtSigHeader vhtSig;
-    if (phyHeaders->RemoveHeader(vhtSig) == 0)
-    {
-        NS_FATAL_ERROR("Missing VHT-SIG header in VHT PPDU");
-    }
-
-    SetTxVectorFromPhyHeaders(txVector, lSig, vhtSig);
-#else
     SetTxVectorFromPhyHeaders(txVector, m_lSig, m_vhtSig);
-#endif
-
     return txVector;
 }
 
@@ -144,32 +111,14 @@
 Time
 VhtPpdu::GetTxDuration() const
 {
-    Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
-
-    uint16_t length = 0;
-    bool sgi = false;
-    bool sgiDisambiguation = false;
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    auto phyHeaders = m_phyHeaders->Copy();
-
-    LSigHeader lSig;
-    phyHeaders->RemoveHeader(lSig);
-    VhtSigHeader vhtSig;
-    phyHeaders->RemoveHeader(vhtSig);
-
-    length = lSig.GetLength();
-    sgi = vhtSig.GetShortGuardInterval();
-    sgiDisambiguation = vhtSig.GetShortGuardIntervalDisambiguation();
-#else
-    length = m_lSig.GetLength();
-    sgi = m_vhtSig.GetShortGuardInterval();
-    sgiDisambiguation = m_vhtSig.GetShortGuardIntervalDisambiguation();
-#endif
-
-    Time tSymbol = NanoSeconds(3200 + txVector.GetGuardInterval());
-    Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
-    Time calculatedDuration = MicroSeconds(((ceil(static_cast<double>(length + 3) / 3)) * 4) + 20);
+    const auto length = m_lSig.GetLength();
+    const auto sgi = m_vhtSig.GetShortGuardInterval();
+    const auto sgiDisambiguation = m_vhtSig.GetShortGuardIntervalDisambiguation();
+    const auto tSymbol = NanoSeconds(3200 + txVector.GetGuardInterval());
+    const auto preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
+    const auto calculatedDuration =
+        MicroSeconds(((ceil(static_cast<double>(length + 3) / 3)) * 4) + 20);
     uint32_t nSymbols =
         floor(static_cast<double>((calculatedDuration - preambleDuration).GetNanoSeconds()) /
               tSymbol.GetNanoSeconds());
@@ -177,8 +126,7 @@
     {
         nSymbols--;
     }
-    ppduDuration = preambleDuration + (nSymbols * tSymbol);
-    return ppduDuration;
+    return (preambleDuration + (nSymbols * tSymbol));
 }
 
 Ptr<WifiPpdu>
@@ -203,42 +151,6 @@
 {
 }
 
-TypeId
-VhtPpdu::VhtSigHeader::GetTypeId()
-{
-    static TypeId tid = TypeId("ns3::VhtSigHeader")
-                            .SetParent<Header>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<VhtSigHeader>();
-    return tid;
-}
-
-TypeId
-VhtPpdu::VhtSigHeader::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
-void
-VhtPpdu::VhtSigHeader::Print(std::ostream& os) const
-{
-    os << "SU_MCS=" << +m_suMcs << " CHANNEL_WIDTH=" << GetChannelWidth() << " SGI=" << +m_sgi
-       << " NSTS=" << +m_nsts << " MU=" << +m_mu;
-}
-
-uint32_t
-VhtPpdu::VhtSigHeader::GetSerializedSize() const
-{
-    uint32_t size = 0;
-    size += 3; // VHT-SIG-A1
-    size += 3; // VHT-SIG-A2
-    if (m_mu)
-    {
-        size += 4; // VHT-SIG-B
-    }
-    return size;
-}
-
 void
 VhtPpdu::VhtSigHeader::SetMuFlag(bool mu)
 {
@@ -337,57 +249,4 @@
     return m_suMcs;
 }
 
-void
-VhtPpdu::VhtSigHeader::Serialize(Buffer::Iterator start) const
-{
-    // VHT-SIG-A1
-    uint8_t byte = m_bw;
-    byte |= (0x01 << 2); // Set Reserved bit #2 to 1
-    start.WriteU8(byte);
-    uint16_t bytes = (m_nsts & 0x07) << 2;
-    bytes |= (0x01 << (23 - 8)); // Set Reserved bit #23 to 1
-    start.WriteU16(bytes);
-
-    // VHT-SIG-A2
-    byte = m_sgi & 0x01;
-    byte |= ((m_sgi_disambiguation & 0x01) << 1);
-    byte |= ((m_suMcs & 0x0f) << 4);
-    start.WriteU8(byte);
-    bytes = (0x01 << (9 - 8)); // Set Reserved bit #9 to 1
-    start.WriteU16(bytes);
-
-    if (m_mu)
-    {
-        // VHT-SIG-B
-        start.WriteU32(0);
-    }
-}
-
-uint32_t
-VhtPpdu::VhtSigHeader::Deserialize(Buffer::Iterator start)
-{
-    Buffer::Iterator i = start;
-
-    // VHT-SIG-A1
-    uint8_t byte = i.ReadU8();
-    m_bw = byte & 0x03;
-    uint16_t bytes = i.ReadU16();
-    m_nsts = ((bytes >> 2) & 0x07);
-
-    // VHT-SIG-A2
-    byte = i.ReadU8();
-    m_sgi = byte & 0x01;
-    m_sgi_disambiguation = ((byte >> 1) & 0x01);
-    m_suMcs = ((byte >> 4) & 0x0f);
-    i.ReadU16();
-
-    if (m_mu)
-    {
-        // VHT-SIG-B
-        i.ReadU32();
-    }
-
-    return i.GetDistanceFrom(start);
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/vht/vht-ppdu.h ns-3.39/src/wifi/model/vht/vht-ppdu.h
--- ns-3.38/src/wifi/model/vht/vht-ppdu.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/vht/vht-ppdu.h	2023-07-05 14:23:48.121428500 -0700
@@ -23,6 +23,7 @@
 #define VHT_PPDU_H
 
 #include "ns3/ofdm-ppdu.h"
+#include "ns3/wifi-phy-operating-channel.h"
 
 /**
  * \file
@@ -48,24 +49,12 @@
      * VHT PHY header (VHT-SIG-A1/A2/B).
      * See section 21.3.8 in IEEE 802.11-2016.
      */
-    class VhtSigHeader : public Header
+    class VhtSigHeader
     {
       public:
         VhtSigHeader();
 
         /**
-         * \brief Get the type ID.
-         * \return the object TypeId
-         */
-        static TypeId GetTypeId();
-
-        TypeId GetInstanceTypeId() const override;
-        void Print(std::ostream& os) const override;
-        uint32_t GetSerializedSize() const override;
-        void Serialize(Buffer::Iterator start) const override;
-        uint32_t Deserialize(Buffer::Iterator start) override;
-
-        /**
          * Set the Multi-User (MU) flag.
          *
          * \param mu the MU flag
@@ -153,16 +142,14 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU
      */
     VhtPpdu(Ptr<const WifiPsdu> psdu,
             const WifiTxVector& txVector,
-            uint16_t txCenterFreq,
+            const WifiPhyOperatingChannel& channel,
             Time ppduDuration,
-            WifiPhyBand band,
             uint64_t uid);
 
     Time GetTxDuration() const override;
@@ -210,10 +197,8 @@
                                    const LSigHeader& lSig,
                                    const VhtSigHeader& vhtSig) const;
 
-#ifndef NS3_BUILD_PROFILE_DEBUG
     VhtSigHeader m_vhtSig; //!< the VHT-SIG PHY header
-#endif
-}; // class VhtPpdu
+};                         // class VhtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-acknowledgment.cc ns-3.39/src/wifi/model/wifi-acknowledgment.cc
--- ns-3.38/src/wifi/model/wifi-acknowledgment.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-acknowledgment.cc	2023-07-05 14:23:48.121428500 -0700
@@ -70,7 +70,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiNoAck::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiNoAck(*this));
+    return std::make_unique<WifiNoAck>(*this);
 }
 
 bool
@@ -78,11 +78,7 @@
                              uint8_t tid,
                              WifiMacHeader::QosAckPolicy ackPolicy) const
 {
-    if (ackPolicy == WifiMacHeader::NO_ACK || ackPolicy == WifiMacHeader::BLOCK_ACK)
-    {
-        return true;
-    }
-    return false;
+    return ackPolicy == WifiMacHeader::NO_ACK || ackPolicy == WifiMacHeader::BLOCK_ACK;
 }
 
 void
@@ -103,7 +99,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiNormalAck::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiNormalAck(*this));
+    return std::make_unique<WifiNormalAck>(*this);
 }
 
 bool
@@ -111,11 +107,7 @@
                                  uint8_t tid,
                                  WifiMacHeader::QosAckPolicy ackPolicy) const
 {
-    if (ackPolicy == WifiMacHeader::NORMAL_ACK)
-    {
-        return true;
-    }
-    return false;
+    return ackPolicy == WifiMacHeader::NORMAL_ACK;
 }
 
 void
@@ -136,7 +128,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiBlockAck::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiBlockAck(*this));
+    return std::make_unique<WifiBlockAck>(*this);
 }
 
 bool
@@ -144,11 +136,7 @@
                                 uint8_t tid,
                                 WifiMacHeader::QosAckPolicy ackPolicy) const
 {
-    if (ackPolicy == WifiMacHeader::NORMAL_ACK)
-    {
-        return true;
-    }
-    return false;
+    return ackPolicy == WifiMacHeader::NORMAL_ACK;
 }
 
 void
@@ -169,7 +157,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiBarBlockAck::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiBarBlockAck(*this));
+    return std::make_unique<WifiBarBlockAck>(*this);
 }
 
 bool
@@ -177,11 +165,7 @@
                                    uint8_t tid,
                                    WifiMacHeader::QosAckPolicy ackPolicy) const
 {
-    if (ackPolicy == WifiMacHeader::BLOCK_ACK)
-    {
-        return true;
-    }
-    return false;
+    return ackPolicy == WifiMacHeader::BLOCK_ACK;
 }
 
 void
@@ -202,7 +186,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiDlMuBarBaSequence::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiDlMuBarBaSequence(*this));
+    return std::make_unique<WifiDlMuBarBaSequence>(*this);
 }
 
 bool
@@ -228,12 +212,7 @@
         return false;
     }
 
-    if (ackPolicy == WifiMacHeader::BLOCK_ACK)
-    {
-        return true;
-    }
-
-    return false;
+    return ackPolicy == WifiMacHeader::BLOCK_ACK;
 }
 
 void
@@ -268,7 +247,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiDlMuTfMuBar::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiDlMuTfMuBar(*this));
+    return std::make_unique<WifiDlMuTfMuBar>(*this);
 }
 
 bool
@@ -277,12 +256,7 @@
                                    WifiMacHeader::QosAckPolicy ackPolicy) const
 {
     // the only admitted ack policy is Block Ack because stations need to wait for a MU-BAR
-    if (ackPolicy == WifiMacHeader::BLOCK_ACK)
-    {
-        return true;
-    }
-
-    return false;
+    return ackPolicy == WifiMacHeader::BLOCK_ACK;
 }
 
 void
@@ -309,7 +283,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiDlMuAggregateTf::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiDlMuAggregateTf(*this));
+    return std::make_unique<WifiDlMuAggregateTf>(*this);
 }
 
 bool
@@ -318,12 +292,7 @@
                                        WifiMacHeader::QosAckPolicy ackPolicy) const
 {
     // the only admitted ack policy is No explicit acknowledgment or TB PPDU Ack policy
-    if (ackPolicy == WifiMacHeader::NO_EXPLICIT_ACK)
-    {
-        return true;
-    }
-
-    return false;
+    return ackPolicy == WifiMacHeader::NO_EXPLICIT_ACK;
 }
 
 void
@@ -350,7 +319,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiUlMuMultiStaBa::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiUlMuMultiStaBa(*this));
+    return std::make_unique<WifiUlMuMultiStaBa>(*this);
 }
 
 bool
@@ -385,7 +354,7 @@
 std::unique_ptr<WifiAcknowledgment>
 WifiAckAfterTbPpdu::Copy() const
 {
-    return std::unique_ptr<WifiAcknowledgment>(new WifiAckAfterTbPpdu(*this));
+    return std::make_unique<WifiAckAfterTbPpdu>(*this);
 }
 
 bool
@@ -393,12 +362,7 @@
                                       uint8_t tid,
                                       WifiMacHeader::QosAckPolicy ackPolicy) const
 {
-    if (ackPolicy == WifiMacHeader::NORMAL_ACK)
-    {
-        return true;
-    }
-
-    return false;
+    return ackPolicy == WifiMacHeader::NORMAL_ACK;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-assoc-manager.cc ns-3.39/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.38/src/wifi/model/wifi-assoc-manager.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-assoc-manager.cc	2023-07-05 14:23:48.121428500 -0700
@@ -117,13 +117,13 @@
         Ssid apSsid;
         if (auto beacon = std::get_if<MgtBeaconHeader>(&apInfo.m_frame); beacon)
         {
-            apSsid = beacon->GetSsid();
+            apSsid = beacon->Get<Ssid>().value();
         }
         else
         {
             auto probeResp = std::get_if<MgtProbeResponseHeader>(&apInfo.m_frame);
             NS_ASSERT(probeResp);
-            apSsid = probeResp->GetSsid();
+            apSsid = probeResp->Get<Ssid>().value();
         }
         if (!apSsid.IsEqual(m_scanParams.ssid))
         {
@@ -234,10 +234,10 @@
     m_mac->ScanningTimeout(std::move(bestAp));
 }
 
-std::list<std::pair<std::uint8_t, uint8_t>>&
+std::list<std::pair<uint8_t, uint8_t>>&
 WifiAssocManager::GetSetupLinks(const StaWifiMac::ApInfo& apInfo)
 {
-    return const_cast<std::list<std::pair<std::uint8_t, uint8_t>>&>(apInfo.m_setupLinks);
+    return const_cast<std::list<std::pair<uint8_t, uint8_t>>&>(apInfo.m_setupLinks);
 }
 
 bool
@@ -254,15 +254,15 @@
     // from Beacon or Probe Response
     if (auto beacon = std::get_if<MgtBeaconHeader>(&m_apList.begin()->m_frame); beacon)
     {
-        mle = beacon->GetMultiLinkElement();
-        rnr = beacon->GetReducedNeighborReport();
+        mle = beacon->Get<MultiLinkElement>();
+        rnr = beacon->Get<ReducedNeighborReport>();
     }
     else
     {
         auto probeResp = std::get_if<MgtProbeResponseHeader>(&m_apList.begin()->m_frame);
         NS_ASSERT(probeResp);
-        mle = probeResp->GetMultiLinkElement();
-        rnr = probeResp->GetReducedNeighborReport();
+        mle = probeResp->Get<MultiLinkElement>();
+        rnr = probeResp->Get<ReducedNeighborReport>();
     }
 
     if (!mle.has_value())
